Subject: Re: Bug: "git-remote ls -h"

From: Junio C Hamano <[email-masked]>
Date: Thu, 30 Jun 2022 11:34:51 -0700

Eric Sunshine <[email-masked]> writes:

> On Wed, Jun 29, 2022 at 11:39 AM Ian Whitlock <[email-masked]> wrote:
>> I found a bug and couldn't find another way to report it. I hope this is okay.
>> The help output for `git ls-remote` shows that `-h` should display remote HEADs, but instead the help output is displayed!
>
> Thanks for the report.
>
>>  ➜ git ls-remote -h
>> usage: git ls-remote [--heads] [--tags] [--refs] [--upload-pack=<exec>]
>>                      [-q | --quiet] [--exit-code] [--get-url]
>>                      [--symref] [<repository> [<refs>...]]
>
> This is a known and documented behavior. The description of the `-h`
> option in the `ls-remote` help page:
>
>     Limit to only refs/heads and refs/tags, respectively. These
>     options are not mutually exclusive; when given both, references
>     stored in refs/heads and refs/tags are displayed. Note that git
>     ls-remote -h used without anything else on the command line gives
>     help, consistent with other git subcommands.

Correct.

I do not mind a patch that teaches ls-remote to emit an extra line
of hint after giving the standard short-help-usage text, telling the
user that "git ls-remote -h origin" (replace 'origin' with whatever
the default remote is) can be used to learn the branches at the
remote.

Thanks.